"""add site

Revision ID: 37d0111fadb3
Revises: ca66316fc3bb
Create Date: 2024-08-26 17:01:12.383520

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '37d0111fadb3'
down_revision = 'ca66316fc3bb'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('objective_score',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('energy', sa.Integer(), nullable=True),
    sa.Column('performance', sa.Integer(), nullable=True),
    sa.Column('cost', sa.Integer(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('sites',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('type', sa.Enum('SLURM_SSH', 'KUBERNETES', name='site_type'), nullable=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('node_pools',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('cpu', sa.Float(), nullable=False),
    sa.Column('memory', sa.BigInteger(), nullable=False),
    sa.Column('maximum_time_in_sec', sa.Float(), nullable=True),
    sa.Column('gpu', sa.Integer(), nullable=True),
    sa.Column('architecture', sa.Enum('X86_64', 'ARM64', name='node_architecture'), nullable=False),
    sa.Column('site_id', sa.String(), nullable=True),
    sa.Column('objective_score_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['objective_score_id'], ['objective_score.id'], ),
    sa.ForeignKeyConstraint(['site_id'], ['sites.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.add_column('action_deployment', sa.Column('node_pool_id', sa.String(), nullable=True))
    op.create_foreign_key(None, 'action_deployment', 'node_pools', ['node_pool_id'], ['id'])
    op.drop_constraint('workflow_action_association_children_fkey', 'workflow_action_association', type_='foreignkey')
    op.drop_constraint('workflow_action_association_parents_fkey', 'workflow_action_association', type_='foreignkey')
    op.create_foreign_key(None, 'workflow_action_association', 'workflow_action', ['parents'], ['id'], ondelete='CASCADE')
    op.create_foreign_key(None, 'workflow_action_association', 'workflow_action', ['children'], ['id'], ondelete='CASCADE')
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'workflow_action_association', type_='foreignkey')
    op.drop_constraint(None, 'workflow_action_association', type_='foreignkey')
    op.create_foreign_key('workflow_action_association_parents_fkey', 'workflow_action_association', 'workflow_action', ['parents'], ['id'])
    op.create_foreign_key('workflow_action_association_children_fkey', 'workflow_action_association', 'workflow_action', ['children'], ['id'])
    op.drop_constraint(None, 'action_deployment', type_='foreignkey')
    op.drop_column('action_deployment', 'node_pool_id')
    op.drop_table('node_pools')
    op.drop_table('sites')
    op.drop_table('objective_score')
    # ### end Alembic commands ###
